package node

import (
	"context"
	"net/http"

	"repository.basistech.ru/BASIS/dynamix-golang-sdk/v14/internal/validators"
)

// SetMemAllocationRatioRequest struct to set memory allocation ratio
type SetMemAllocationRatioRequest struct {
	// Node ID
	// Required: true
	NodeID uint64 `url:"node_id" json:"node_id" validate:"required"`

	// Allocation ratio (zero or positive value)
	// Required: true
	Ratio float64 `url:"ratio" json:"ratio" validate:"required"`
}

// SetMemAllocationRatio set memory allocation ratio
func (i Node) SetMemAllocationRatio(ctx context.Context, req SetMemAllocationRatioRequest) error {
	err := validators.ValidateRequest(req)
	if err != nil {
		return validators.ValidationErrors(validators.GetErrors(err))
	}

	url := "/cloudbroker/node/set_mem_allocation_ratio"

	_, err = i.client.DecortApiCall(ctx, http.MethodPost, url, req)
	if err != nil {
		return err
	}

	return nil
}
